'VBScript example for OstroSoft SMTP Component
'written by Igor Ostrovsky (OstroSoft)
'
'For more information about OstroSoft SMTP Component go to
'http://www.ostrosoft.com/ossmtp.aspx

Option Explicit

Dim oSMTP 'As OSSMTP.SMTPSession
Dim sStatus 'As String
Dim bClose 'As Boolean
Dim nTimeout 'As Long
Dim n 'As Long

sStatus = ""
bClose = False
nTimeout = 1000
n = 0

Set oSMTP = CreateObject("OSSMTP.SMTPSession")
WScript.ConnectObject oSMTP, "oSMTP_"

oSMTP.Server = "localhost" 'server name or IP address
oSMTP.MailFrom = "info@localhost" 'sender e-mail address
oSMTP.SendTo = "test@localhost" 'recipient e-mail address
oSMTP.MessageSubject = "test message" 'message subject
oSMTP.MessageText = "this is " & vbCrLf & "multi-line test" 'message text

''2 ways to add an attachment
''simplified syntax (without Attachment object):
'oSMTP.Attachments.Add "c:\Temp\file1.zip"

''advanced syntax (using Attachment object):
'Dim oAttachment
'Set oAttachment = CreateObject("OSSMTP.Attachment")
'oAttachment.FilePath = "c:\Temp\file2.zip"
'oAttachment.AttachmentName = "smtp_vbscript"
'oAttachment.ContentType = "application/x-zip-compressed"
'oAttachment.ContentTransferEncoding = 0 '1 - enc7Bit, 2 - encBase64)
'oSMTP.Attachments.Add oAttachment

''connection and authentication
'oSMTP.Port = 465 'default SMTP port is 25, otherwise set it here
'oSMTP.AuthenticationType = 2 'most mailservers require authentication, values for this field are: 0 (default) - no authentication, 1 - authentication via POP3 session (obsolete), 2 - AUTH LOGIN, 3 - AUTH PLAIN, 4 - NTLM
'oSMTP.Username = "<your mailserver login>"
'oSMTP.Password = "<your mailserver password>"
'oSMTP.UseSSL = false 'set to true for mailservers requiring connection over SSL

'oSMTP.CustomHeaders.Add "x-custom-header: some value" 'add custom header

'oSMTP.EmbeddedObjects.Add "c:\temp\avatar.jpg" 'add embedded image
'oSMTP.MessageHTML = "<html><body>this is embedded image<br><img src=""cid:avatar.jpg""></body></html>" 'use added image

oSMTP.RaiseError = True 'when property set to True, component raises an error, otherwise - fires ErrorSMTP event

oSMTP.SendEmail

Sub oSMTP_ConnectSMTP()
'connected to mailserver
End Sub

Sub oSMTP_SendSMTP()
'message successfully sent
End Sub

Sub oSMTP_StatusChanged(ByVal Status)
  sStatus = sStatus & oSMTP.Status & vbCrLf
End Sub

Sub oSMTP_ErrorSMTP(ByVal Number, Description)
'error occured
  sStatus = sStatus & "Error " & Number & ": " & Description & vbCrLf
  bClose = True
End Sub

Sub oSMTP_CloseSMTP()
'connection to mailserver closed
  bClose = True
End Sub

Do While Not bClose
  WScript.Sleep 1
  n = n + 1
  If n > nTimeout Then
    sStatus = sStatus & "Timeout" & vbCrLf
    Exit Do
  End If
Loop

WScript.Echo sStatus
Set oSMTP = Nothing
